// Programm: Matrix Bildschirmschoner
// Autor: Markus Stehr aka. BastetFurry (c)2005
// Lizenz: GPL
//
// Sinn des Programms: Darstellung des aus Matrix bekannten Bildschirmcodes

// Die blichen verdchtigen
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>

// Variablendeklaration
unsigned char stelle;       // Beinhaltet die Spalte die zZ bearbeitet wird
unsigned char laenge[40];   // Array der Lngen der Buchstabenschlangen
unsigned int ende[40];      // Array der letzten Zeile der Buchstabenschlange
unsigned char done;         // Sind wir fertig? Wird in diesem Programm nicht erreicht
unsigned char XSize, YSize; // Hier kommen die Bildschirmgrssen rein

// Diese Routine erstellt eine Buchstabenschlange neu
void zufallslinie()
{
  laenge[stelle]=(rand()%20)+1;
	ende[stelle]=-1;
}

// Diese Routine manipuliert den Farbspeicher
// Schick wenn man den gesamten Speicher wie ein Array behandeln kann *g*
#define farbesetzen(fs_x,fs_y,fs_farbe) COLOR_RAM[(fs_y-1)*40+fs_x] = fs_farbe

/*void farbesetzen(char fs_x,char fs_y, char fs_farbe)
{
  COLOR_RAM[(fs_y-1)*40+fs_x] = fs_farbe;
}
*/

int main(void)
{
  screensize (&XSize, &YSize);  // Bildschirmgrsse ermitteln
	_randomize();  // Zufallszahlen setzen
  // Bildschirm vorbereiten
  textcolor (COLOR_WHITE);
  bordercolor (COLOR_BLACK);
  bgcolor (COLOR_BLACK);
  cursor (0);
	clrscr();      // Bildschirm lschen

  // Infotext
  printf("MATRIX-Demo by BastetFurry\n");
  printf("nachtkatzen productions (c)2005\n");
  printf("----------------------------------------");
  printf("Dieses Programm darf frei kopiert werden\n\n");
  printf("Auf die Idee kam ich durch einen Contest");
  printf("auf der 2004er Hobbytronic.\n");
  printf("Ziel war es mit CBM-BASIC *grusel* einen");
  printf("Matrix Bildschirmschoner zu schreiben.\n");
  printf("Ich schafte es auch, aber das Proggy\n");
  printf("war langsam, und selbst ein Basic-\n");
  printf("compiler konnte da nicht viel retten.\n");
  printf("Nun bin ich auf CC65 gestossen und mein\n");
  printf("Erstlingswerk liegt in eurer Floppy.\n");
  printf("Ich hoffe ich als verwoehnter PC-Coder\n");
  printf("bringe euch hiermit etwas Spass\n");
  printf("auf eurem Bildschirm ;)\n");
  printf("Vielleicht kommt ja nochmal was\n");
  printf("groesseres von mir!\n\n");
  printf("Bitte Programm \"Entern\" !");
  getchar(); // Warte auf Enter
  clrscr();

  for(stelle=0;stelle<XSize;stelle++)
  {
    zufallslinie();
  }

  while(!done)
  {
    for(stelle=0;stelle<XSize;stelle++)
    {
      ende[stelle]++;
      if(ende[stelle]>YSize-1)ende[stelle]=YSize-1;
      if(ende[stelle]>0)
      {
      	farbesetzen(stelle,ende[stelle]-1,COLOR_GREEN);
      	gotoxy(stelle,ende[stelle]);
        cputc((rand()%128)+32);
      }
    }

    for(stelle=0;stelle<XSize;stelle++)
    {
      if(ende[stelle]==YSize-1)laenge[stelle]--;
      	gotoxy(stelle,ende[stelle]-laenge[stelle]-1);
        cputc(32);
      	gotoxy(stelle,ende[stelle]-laenge[stelle]);
        cputc(32);

      if(laenge[stelle]==1)
      {
      	gotoxy(stelle,ende[stelle]);
        cputc(32);
        zufallslinie();
      }
    }


  } // Ende while(!done)

} // Ende main()


